%define name	lxr
%define version	0.3.1
%define release	2AX
%define _lxrdir /var/www/%{name}

Summary:	The Linux Cross-Reference project is the testbed application of a general hypertext cross-referencing tool.
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		Development/Tools
Source:		http://prdownloads.sourceforge.net/lxr/%{name}-%{version}.tar.gz
Source1:	lxr.cron
Source2:	lxr-htdig.cron
Source3:	lxr-htaccess
Source4:	lxr.conf.miracle
Source5:	lxr-pengmini.gif
Patch0:         lxr-0.3.1.patch
URL:		http://sourceforge.net/projects/lxr
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
BuildArch:	noarch
BuildRequires:	perl
Requires:	ctags, webserver, mod_perl, unzip, perl >= 5.600

%description
The Linux Cross-Reference project is the testbed application of a general hypertext
cross-referencing tool. (Or the other way around.)

The main goal of the project is to create a versatile cross-referencing tool for relatively
large code repositories. The project is based on stock web technology, so the codeview
client may be chosen from the full range of available web browsers. On the server side, the
prototype implementation is based on an Apache web server, but any Unix-based web server
with cgi-script capability should do nicely. (The prototype implementaion is running on a
dual Pentium Pro Linux box.)

The main feature of the indexer is of course the ability to jump easily to the declaration
of any global identifier. Indeed, even all references to global identifiers are indexed.
Quick access to function declarations, data (type) definitions and preprocessor macros makes
code browsing just that tad more convenient. At-a-glance overview of e.g. which code areas
that will be affected by changing a function or type definition should also come in useful
during development and debugging.

Other bits of hypertextual sugar, such as e-mail and include file links, are provided as
well, but is on the whole, well, sugar. Some minimal visual markup is also done. (Style
sheets are considered as a way to do this in the future.)

%prep
%setup -q -n lxr-0.3
%patch0 -p1

%build
make

%install
rm -rf %{buildroot}

%__install -d %{buildroot}%{_sysconfdir}
%__install -d %{buildroot}%{_sysconfdir}/httpd/conf
%__install -d %{buildroot}%{_sysconfdir}/cron.daily
%__install -d %{buildroot}%{_bindir}
%__install -d %{buildroot}%{_datadir}/%{name}
%__install -d %{buildroot}%{_lxrdir}
%__install -d %{buildroot}%{_lxrdir}/lib
%__install -d %{buildroot}%{_lxrdir}/lib/LXR
%__install -d %{buildroot}%{_lxrdir}/templates

%__install -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/%{name}.conf
( cd %{buildroot}%{_lxrdir}; %__ln_s %{_sysconfdir}/%{name}.conf . )

%__install -m 755 %{SOURCE1} %{buildroot}%{_sysconfdir}/cron.daily/
%__install -m 755 %{SOURCE2} %{buildroot}%{_sysconfdir}/cron.daily/

for file in diff find genxref ident search source; do
    %__install -m 755 $file %{buildroot}%{_lxrdir}/$file
done

( cd %{buildroot}%{_bindir}; %__ln_s %{_sysconfdir}/cron.daily/%{name}.cron genxref )

%__install -m 644 %{SOURCE3} %{buildroot}%{_lxrdir}/.htaccess
%__install -m 644 %{SOURCE5} %{buildroot}%{_lxrdir}/pengmini.gif

%__install -m 644 http/template-* %{buildroot}%{_lxrdir}/templates/
%__install -m 644 http/*.html %{buildroot}%{_lxrdir}/templates/
%__install -m 644 SimpleParse.pm %{buildroot}%{_lxrdir}/lib
%__install -m 644 Common.pm Config.pm %{buildroot}%{_lxrdir}/lib/LXR

%__cat > %{buildroot}%{_sysconfdir}/httpd/conf/%{name}-apache.conf << EOF

# Automatically set up by lxr RPM

Alias /lxr /var/www/lxr

<Directory /var/www/lxr>
    AllowOverride All
</Directory>

EOF


%post
if [ "$1" = 1 ]; then
    alllinux="`find /usr/src/ -type d -name "linux-*" -maxdepth 1 -printf "%f "`"
    /usr/bin/perl -pi -e "s|linux-xxx|$alllinux|" /etc/lxr.conf
    /usr/bin/perl -pi -e "s|default-xxx|`echo "$alllinux" | awk '{print $1}'`|" /etc/lxr.conf
    /usr/bin/perl -pi -e "s|urlxxx|`/bin/hostname`|" /etc/lxr.conf
    /usr/bin/perl -pi -e "s|urlxxx|`/bin/hostname`|" /etc/cron.daily/lxr.cron
    if [ -f /etc/httpd/conf/httpd.conf ]; then
	/bin/egrep "Include conf/lxr-apache.conf" /etc/httpd/conf/httpd.conf > /dev/null
	if [ $? = 1 ]; then
	    echo "# Automatically set up by lxr RPM" >> /etc/httpd/conf/httpd.conf
	    echo "Include conf/lxr-apache.conf" >> /etc/httpd/conf/httpd.conf
	    /sbin/service httpd update > /dev/null 2>&1 || :
	fi
    fi
fi

%preun
if [ "$1" = 0 ]; then
    if [ -f /etc/httpd/conf/httpd.conf ]; then
	/bin/egrep "^Include conf/lxr-apache.conf" /etc/httpd/conf/httpd.conf > /dev/null
	if [ $? = 0 ]; then
	    /usr/bin/perl -pi -e 's|^(Include conf/lxr-apache.conf*)|# $1|' /etc/httpd/conf/httpd.conf
	    /sbin/service httpd update > /dev/null 2>&1 || :
	fi
    fi
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc COPYING INSTALL README
%doc http/lxr.conf
%config(noreplace) %{_sysconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/%{name}-apache.conf
%{_sysconfdir}/cron.daily/lxr.cron
%{_sysconfdir}/cron.daily/lxr-htdig.cron
%{_bindir}/genxref
%dir %{_lxrdir}
%{_lxrdir}/lxr.conf
%{_lxrdir}/diff
%{_lxrdir}/find
%{_lxrdir}/genxref
%{_lxrdir}/ident
%{_lxrdir}/search
%{_lxrdir}/source
%dir %{_lxrdir}/lib
%{_lxrdir}/lib/SimpleParse.pm
%dir %{_lxrdir}/lib/LXR
%{_lxrdir}/lib/LXR/*.pm
%dir %{_lxrdir}/templates
%{_lxrdir}/templates/template-*
%{_lxrdir}/templates/*.html
%{_lxrdir}/.htaccess
%{_lxrdir}/pengmini.gif

%changelog
* Fri Jun 11 2004 Xin Zhang    <xin.zhang@oracle.com> 0.3.1-2AX
- patch to lxr-0.3/genxref.in to set correct permission of database
  file "fileidx", which is created by "genxref" command

* Wed Jun  2 2004 Shiro Yamada <shiro@miraclelinux.com> 0.3.1-1AX
- first build for Asianux 1.0
- replaced the base with 0.3.1 (stable version)

* Sun Aug 24 2003 Andre DUCLOS <shirka@wanadoo.fr> 0.9.2-1shk
- 9.2

* Wed Feb 27 2002 Andre DUCLOS <shirka@wanadoo.fr> 0.9.1-1shk
- first Mandrake version.    
